<?php
/***********************************************************************************/
/* Post Thumb Revisited Main functions
/*
/* 	function the_thumb ($arg='')
/* 	function get_thumb ($arg='')
/*		Loop function. Returns the formatted thumbnail of the current post
/*		or object (depending on parameters)
/*
/* 	function get_thumb_url ()
/*
/*	function the_recent_thumbs ($arg='', $beforeli='', $afterli='', $before='', $after='')
/*	function get_recent_thumbs ($arg='', $beforeli='', $afterli='', $before='', $after='')
/*		Anywhere function. Returns thumbnails of the most recent posts
/*
/* 	function the_random_thumb ($arg='', $beforeli='', $afterli='', $before='', $after='')
/*	function get_random_thumb ($arg='', $beforeli='', $afterli='', $before='', $after='')
/*		Anywhere function. Returns thumbnail(s) from random post(s)
/*
/*	function pt_the_excerpt($length=40, $title_after= false, $arg='')
/*		Loop function. Returns Thumbnail (+ Title) + Excerpt
/*
/*	function get_single_thumb ($post, $arg='')
/*	function get_recent_medias ($arg='', $beforeli='', $afterli='', $before='', $after='')
/*	function get_WTMedia ($vid, $arg='', $play_width=0, $play_height=0)
/*	function get_WTPlaylist ($pid, $arg='', $play_width=0, $play_height=0, $mp3=false, $flv=false)
/*	function get_wordTubeTag ($content='')
/*	function get_Youtube ($id, $title, $thumb)
/*	function RecentImages ($arg='', $slice=5, $timeout=0)
/*	function RecentImages_sub ($ListImages, $slice, $offset, $i, $limit)
/*
/***********************************************************************************/


/***********************************************************************************/
/* display thumbnail. Loop function.
/***********************************************************************************/
function the_thumb ($arg='') {

	echo get_thumb($arg);
}
/***********************************************************************************/
/* Get thumbnail. Loop function.
/***********************************************************************************/
function get_thumb ($arg='') {
	global $PTRevisited;

		return $PTRevisited->GetThumb($arg);
}
/***********************************************************************************/
/* Get post image url. Loop function.
/***********************************************************************************/
function get_thumb_url () {
	global $PTRevisited, $post;

		setup_postdata($post);
		$array =  $PTRevisited->GetPostData($post->ID);
		if ($array !='') return $array['image_url'];
		return '';
	
}
/***********************************************************************************/
/* Get thumbnail for a given post
/***********************************************************************************/
function get_single_thumb ($post, $arg='') {
	global $PTRevisited;
		return $PTRevisited->GetSingleThumb($post, $arg);
}
/****************************************************************/
/* Includes features in header
/****************************************************************/
function pt_include_header() {
	global $PTRevisited;
		return $PTRevisited->include_header();
}
/***********************************************************************************/
/* Get Post-Thumb Revisited options.
/***********************************************************************************/
function get_pt_options($option) {
	global $PTRevisited;
		return $PTRevisited->settings[$option];
}
/***********************************************************************************/
/* Get Post-Thumb Revisited options.
/***********************************************************************************/
function get_pt_options_all() {
	global $PTRevisited;
		return $PTRevisited->settings;
}
/********************************************************************************************************/
/*
/* Utility functions for Post-thumb revisited
/*
/********************************************************************************************************/


/****************************************************************/
/* Get formatted youtube video

<object width="425" height="355">
 	<param name="movie" value="http://www.youtube.com/v/bqJE5TH5jhc&rel=1"></param>
 	<param name="wmode" value="transparent"></param>
 	<embed src="http://www.youtube.com/v/bqJE5TH5jhc&rel=1" type="application/x-shockwave-flash" wmode="transparent" width="425" height="355">
	</embed>
</object>

/****************************************************************/
function SetYoutubeVideo ($ytb_ID, $title='', $thumb, $settings, $add_arg='') {

	$ID = 'y'.rand();
	$url = 'http://youtube.com/watch?v='.$ytb_ID;
	if ($title == '') $title = 'Youtube video';
	$replacement = "\n".'<script type="text/javascript">';
	$replacement .= "\n\t".'var so'.$ID.'y = new SWFObject("http://youtube.com/v/'.$ytb_ID.'&amp;autoplay=1"';
	$replacement .= ', "1", "'.$settings['youtube_pwidth'].'", "'.$settings['youtube_pheight'].'", "7", "'.get_pt_options('bgcolor').'");';
	$replacement .= "\n\t".'so'.$ID.'y.addParam("wmode", "transparent");';
	if (class_exists('pt_thickbox')) $replacement .= "\n\t".'so'.$ID.'y.write("myBody'.$ID.'");';
	$replacement .= "\n".'</script>'."\n";

	if (class_exists('pt_highslide')) {
	
		$h = new pt_highslide($url, $thumb, $title);
		$h->set_wrapClass('highslide-wrapper-ytb');
		$h->set_borders($settings['hsframe']);
		$h->set_size($settings['youtube_pwidth'], $settings['youtube_pheight'], $settings['hsmargin']);
		$h->set_href_text($title, $add_arg);
		$h->set_bottom(__('Direct link to: ', 'post-thumb').$title, $url);
		$replacement .= $h->highslide_link('swfObject', 'so'.$ID.'y');
	
		unset($h);
	}
	elseif (class_exists('pt_thickbox')) {
	
		$h = new pt_thickbox($url, $thumb, $title);
		$h->set_size($settings['youtube_pwidth']+5, $settings['youtube_pheight']+10);
		$h->set_href_text($title);
		$h->set_body($replacement);
		$replacement = $h->thickbox_link('swfObject', $ID);
	
		unset($h);
	} 
	else {
		$replacement = "\n".'<object data="http://youtube.com/v/'.$ytb_ID.'" type="application/x-shockwave-flash" width="'.$settings['youtube_pwidth'].'" height="'.$settings['youtube_pheight'].'">';
	  	$replacement .=	"\n\t".'<param name="movie" value="http://youtube.com/v/'.$ytb_ID.'" />';
		$replacement .=	"\n".'</object>';
	}


	return $replacement;
}
/****************************************************************/
/* Parse given attributes of an html string
/****************************************************************/
function pt_parseAtributes($html, $attrList=array ("src", "alt", "title", "align")) {

	$html = trim($html);
	$ListAttr = array();
	
	foreach ($attrList as $attr) :
		$ListAttr[$attr]= pt_parseAttribute($html, $attr);
	endforeach;
	
	return $ListAttr;
}
function pt_parseAttribute($html, $attr) {

	if (($pos=stripos($html, $attr)) === false) return '';
	$html = substr($html, $pos);
	$html = str_replace($attr, '', $html);
	$html = ltrim($html);
	$html = substr($html, 2);
	if (($pos=stripos($html, '"')) === false) {
		if (($pos=stripos($html, "'")) === false) return '';
	}
	return substr($html, 0, $pos);
}
/***********************************************************************************/
/* extended pathinfo (for php4)
/***********************************************************************************/
function pt_pathinfo($path) {

	$tab = pathinfo($path);
	$tab['filename'] = substr($tab['basename'],0,strlen($tab['basename']) - (strlen($tab['extension']) + 1) );
	return $tab;
}
/***********************************************************************************/
/* Parse arguments
/***********************************************************************************/
function pt_parse_arg ($arg) {

	parse_str($arg, $new_args);
	return array_change_key_case($new_args, CASE_UPPER);

}
/***********************************************************************************/
/* Exclude some REGEX from a content
/***********************************************************************************/
function exclude_regex ($content) {

	$result = $content;
	$reg_coolplayer = '/\[coolplayer](.*?)\[\/coolplayer]/i';
	$reg_youtube = '/\[youtube](.*?)\[\/youtube]/i';
	$reg_dailymotion = '/\[dailymotion](.*?)\[\/dailymotion]/i';
	$reg_googlevideo = '/\[googlevideo](.*?)\[\/googlevideo]/i';
	$reg_wordtube = '/\[MEDIA=(.*?)]/i';
	$reg_extremevideo = '/\[ev(.*?)\[\/ev]/i';

	$pt_youtube = '/\[youtube=\((.*?)\)\]/i';
	$pt_youtubebis = '/\[youtube=(.*?)\]/i';
	$easyTube = '/\[youtube:(.*?)\]/i';
 	$pt_dailymotion = '/\[dailymotion=\((.*?)\]/i';

	$content = preg_replace($reg_coolplayer, '...', $content);
	$content = preg_replace($reg_youtube, '...', $content);
	$content = preg_replace($reg_dailymotion, '...', $content);
	$content = preg_replace($reg_googlevideo, '...', $content);
	$content = preg_replace($reg_wordtube, '...', $content);
	$content = preg_replace($reg_extremevideo, '...', $content);
	$content = preg_replace($pt_youtube, '...', $content);
	$content = preg_replace($pt_youtubebis, '...', $content);
	$content = preg_replace($easyTube, '...', $content);
	$content = preg_replace($pt_dailymotion, '...', $content);

	return $content;
}
/****************************************************************
* Test if remote image exists
* @param url to test
* @return true if file exists
****************************************************************/
function remote_file_exists ($uri) {

	if (@file_exists($uri)) return true;

	$parsed_url = @parse_url($uri);
	if ( !$parsed_url || !is_array($parsed_url) )
		return false;

	if ( !isset($parsed_url['scheme']) || !in_array($parsed_url['scheme'], array('http','https')) )
		$uri = 'http://' . $uri;

	if ( ini_get('allow_url_fopen') ) {
		if (@fclose(@fopen($uri, 'r')) !== false) return true;
	}

	if ( function_exists('curl_init') ) {

		$timeout = 50;
		$handle = curl_init();
		curl_setopt ($handle, CURLOPT_MUTE, TRUE);
		curl_setopt ($handle, CURLOPT_URL, $uri);
		curl_setopt ($handle, CURLOPT_CONNECTTIMEOUT, 2);
		curl_setopt ($handle, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt ($handle, CURLOPT_TIMEOUT, $timeout);
		$buffer = curl_exec($handle);
		curl_close($handle);
		if ($buffer !== false) return true;
	}

	if ( function_exists('get_headers') ) {

		$AgetHeaders = @get_headers($uri);
		if (preg_match("|200|", $AgetHeaders[0])) return true;

	}

	return false;

}
/****************************************************************/
/* retourne un chemin canonique a partir d'un chemin contenant des ../
/****************************************************************/
function canonicalize($address) {

	$address = explode('/', $address);
	$keys = array_keys($address, '..');

	foreach($keys AS $keypos => $key)
	{
		array_splice($address, $key - ($keypos * 2 + 1), 2);
	}

	$address = implode('/', $address);
	$address = str_replace('./', '', $address);
	return $address;
}
/****************************************************************/
/*
/****************************************************************/
function pt_clean_text($text, $no_semiologic=false) {

	$text = strip_tags(stripslashes($text));

	if (function_exists('jLanguage_processTitle'))
		$text = jLanguage_processTitle($text);

	$pattern = '/\[MEDIA=([^\]]*)\]/i';
        $text = preg_replace($pattern,'',$text);
	$pattern = '/\[PTPLAYLIST=([^\]]*)\]/i';
        $text = preg_replace($pattern,'',$text);
	$pattern = '/\[dailymotion=([^\]]*)\]/i';
        $text = preg_replace($pattern,'',$text);
	$pattern = '/\[youtube([^\]]*)\]/i';
        $text = preg_replace($pattern,'',$text);
	$pattern = '/\[PTSET=([^\]]*)\]/i';
        $text = preg_replace($pattern,'',$text);
	$pattern = '/\[PTALBUM=([^\]]*)\]/i';
        $text = preg_replace($pattern,'',$text);
	$pattern = '/\[PTTAG=([^\]]*)\]/i';
        $text = preg_replace($pattern,'',$text);

	// This is for semiologic smart link plugin
	if ($no_semiologic) {

        	$pattern = '/\[([^\]]*)\-(\>|\&gt)([^\]]*)\]/i';
        	if (preg_match_all($pattern, $text, $matches, PREG_SET_ORDER)) {
        	
        		foreach ($matches as $match) :
				$text = str_replace($match[0], $match[1], $text);
                        endforeach;
		}
	}

	// Trim all unwanted/unnecessary characters
	return rtrim($text, "\s\n\t\r\0\x0B");
}
/****************************************************************/
/* Return a string cleaned of annoying '\'
/****************************************************************/
function str_clean ($item)
{
	return str_replace(array("\`", "\'", '\"'), array("`", "'", '"'), $item);
}
/****************************************************************/
/* Returns a formatted url for inframe display
/****************************************************************/
function pt_return_get ($url, $if=1) {

	$look_get = strpos($url,'?');
	$end_char = substr($url, -1, 1);
	if ($end_char == '/') $url_inframe = substr($url, 0, strlen($url)-1); else $url_inframe = $url;
	if ($look_get !== false) $url_inframe .= "&amp;inframe=".$if; else $url_inframe .= "?inframe=".$if;
	return $url_inframe;
}
/*******************************************************************************/
/* Change relative url to absolute
/*******************************************************************************/
function NormalizeURL($url) {
	
	// Test if url is absolute
	if ( stristr( $url, 'http://' )) return $url;
	
	$siteurlparsed = parse_url(SITEURL);
	$host = $siteurlparsed['scheme'].'://'.$siteurlparsed['host'];
	// If http not in url, assumes relative address to blog url
	return canonicalize($host.$url);
	
}
/****************************************************************/
/* Gets options. Sets minimum options to operate before first validation.
/****************************************************************/
function pt_GetStarterOptions() {

	// Init parameters
	$up = UPLOAD_PATH;
	$pa = parse_url(SITEURL);
	$path = substr($pa['path'], 1, strlen($pa['path'])-1);
	
	$dn = str_replace($pa['path'],"",SITEURL);
	$bp = str_replace($pa['path'],"",str_replace( "\\", "/",ABSPATH));
	$bp = substr($bp, 0, strlen($bp)-1);
	$def = $path.'/wp-content/plugins/'. PT_PLUGIN_BASENAME.'/images/default.png';
	
	$settings = get_option('post_thumbnail_settings');

	if ($settings['append'] == '') 		$settings['append'] = 'false';
	if ($settings['append_text'] == '') 	$settings['append_text'] = 'thumb_';
	if ($settings['base_path'] == '') 	$settings['base_path'] = $bp;
	if ($settings['default_image'] == '') 	$settings['default_image'] = $def;
	if ($settings['folder_name'] == '') 	$settings['folder_name'] = $path.'/'.$up.'/pth';
	if ($settings['full_domain_name'] == '')$settings['full_domain_name'] = str_replace( "\\", "/",$dn);

	if ($settings['tb_use'] == '') 		$settings['tb_use'] = 'false';
	if ($settings['hs_use'] == '') 		$settings['hs_use'] = 'false';

	$settings['jpg_rate'] 			= ptr_test_setting($settings['jpg_rate'], '75', 100);
	if ($settings['keep_ratio'] == '') 	$settings['keep_ratio'] = 'true';
	$settings['png_rate'] 			= ptr_test_setting($settings['png_rate'], '6', 9);

	$settings['resize_width'] 		= ptr_test_setting($settings['resize_width'], '60');
	$settings['resize_height'] 		= ptr_test_setting($settings['resize_height'], '60');

	if ($settings['rounded'] == '') 	$settings['rounded'] = 'false';
	if ($settings['stream_check'] == '') 	$settings['stream_check'] = 'false';

	if ($settings['unsharp'] == '') 	$settings['unsharp'] = 'false';

	if ($settings['use_catname'] == '') 	$settings['use_catname'] = 'false';
	if ($settings['use_meta'] == '') 	$settings['use_meta'] = 'true';
	if ($settings['use_png'] == '') 	$settings['use_png'] = 'false';

	if ($settings['video_default'] == '') 	$settings['video_default'] = $def;
	if ($settings['pt_replace'] == '') 	$settings['pt_replace'] = 'false';

	return $settings;
}
/***********************************************************************************/
/* Valids a numeric number vs a default value
/***********************************************************************************/
function ptr_test_setting($option, $default, $max = 0) {

	$option = trim($option);
	if (!is_numeric($option) || ($option > $max && $max <> 0 ))

		return $default;
	else
		return $option;
}
/***********************************************************************************/
/* Simple check of flv-ness of a file
/***********************************************************************************/
function pt_is_flv ($file) {
	return (stripos($file, '.flv') !== false);
}
function has_to_be_loaded() {

	$uri = $_SERVER['REQUEST_URI'];
	$self = $_SERVER['PHP_SELF'];
	
	if (stripos($uri, 'deactivate') !== false) return false;
	if (stripos($self, 'edit') !== false) return true;
	if (stripos($uri, 'delete') !== false) return true;
	if (stripos($self, 'post') !== false) return true;
	if (stripos($self, 'option') !== false) return true;
	if (stripos($self, 'plugin') !== false && stripos($uri, 'activate') !== false) return true;
	
	return false;
}
/***********************************************************************************/
/* function for php4
/***********************************************************************************/
if (!function_exists('stripos')) {
	function stripos($str, $mix) { 
		return strpos(strtolower($str), strtolower($mix));
	}
}
if (!function_exists('file_put_contents')) {
	define('FILE_APPEND', 1);
	function file_put_contents($n, $d, $flag = false) {
		$mode = ($flag == FILE_APPEND || strtoupper($flag) == 'FILE_APPEND') ? 'a' : 'w';
		$f = @fopen($n, $mode);
		if ($f === false) {
			return false;
		} else {
			if (is_array($d)) $d = implode($d);
			$bytes_written = fwrite($f, $d);
			fclose($f);
			return $bytes_written;
		}
	}
}
if( !function_exists('memory_get_usage') ) {
	function memory_get_usage() {

		//If its Windows
		//Tested on Win XP Pro SP2. Should work on Win 2003 Server too
		//Doesn't work for 2000
		//If you need it to work for 2000 look at http://us2.php.net/manual/en/function.memory-get-usage.php#54642
		if ( substr(PHP_OS,0,3) == 'WIN') {
			if ( substr( PHP_OS, 0, 3 ) == 'WIN' ) {
				$output = array();
				exec( 'tasklist /FI "PID eq ' . getmypid() . '" /FO LIST', $output );
        
				return preg_replace( '/[\D]/', '', $output[5] ) * 1024;
			}
		} else {

			//We now assume the OS is UNIX
			//Tested on Mac OS X 10.4.6 and Linux Red Hat Enterprise 4
			//This should work on most UNIX systems
			$pid = getmypid();

			// exec("ps -o rss -p $pid", $output);   // Uncomment this line for  MAC OS X 10.4 (Intel)
			exec("ps -eo%mem,rss,pid | grep $pid", $output); // Comment this line for MAC OS X 10.4 (Intel)
			$output = explode("  ", $output[0]);

			//rss is given in 1024 byte units
			return $output[1] * 1024;
		}
	}
} 
/***********************************************************************************/
/* load cache file - timeout in minutes
/***********************************************************************************/
function pt_load_cache($filename, $dirname, $timeout=0) {
		
	if (!file_exists($dirname.$filename)) return false;

	// Test if cache has expired
	$diff = (time() - filemtime($dirname.$filename))/60;
	if ($diff >= $timeout && $timeout != 0) return false;
		
	// Read content from cache file.
	$content = file_get_contents($dirname.$filename);
		
	if ($content === false) return false;

	return unserialize($content);
		
}
/***********************************************************************************
	save cache file
***********************************************************************************/
function pt_save_cache($filename, $dirname, $content) {

	$content = serialize($content);

	if (!is_dir($dirname)) {
		$old_umask = umask(0);
		@mkdir($dirname, 0777);
		umask($old_umask);
		if (!is_dir($dirname)) return false;
	}

	// Writes content from cache file.
	$content = file_put_contents($dirname.$filename, $content);

}
/***********************************************************************************
	For WP below 2.1
***********************************************************************************/
if (!function_exists('sanitize_file_name')) {
	function sanitize_file_name( $name ) { // Like sanitize_title, but with periods
		$name = strtolower( $name );
		$name = preg_replace('/&.+?;/', '', $name); // kill entities
		$name = str_replace( '_', '-', $name );
		$name = preg_replace('/[^a-z0-9\s-.]/', '', $name);
		$name = preg_replace('/\s+/', '-', $name);
		$name = preg_replace('|-+|', '-', $name);
		$name = trim($name, '-');
		return $name;
	}
}
/************************************************************************/
/* Substr function so that utf8 char are not truncate
/************************************************************************/
function utf8_substr($str,$start=0, $myend=15) {

	preg_match_all("/./su", $str, $ar);

	if(func_num_args() >= 3) {
		$end = func_get_arg(2);
		return join("",array_slice($ar[0],$start,$end));
	} else {
		return join("",array_slice($ar[0],$start));
	}
}
/************************************************************************/
/* Unicode aware replacement for strlen()
/************************************************************************/
function utf8_strlen($string){
	return strlen(utf8_decode($string));
}
/***********************************************************************************/
/* Get wordTube media.
/***********************************************************************************/
function get_ReturnMedia( $ID, $video_id, $act_file, $act_image='', $new_width=0, $new_height=0, $autostart=false, $exc=true, $use_tb=false) {
	global $WPwordTube;

	$replace = $WPwordTube->ReturnMedia($video_id, $act_file, $act_image, $new_width, $new_height, $autostart);
	$tmp = explode('so.write', $replace);
	$replace = $tmp[0];
	$tmp = explode('</div>', $replace);
	$replace = $tmp[1];
	if ($WPwordTube->wordtube_options['xhtmlvalid']) $replace .= $WPwordTube->xmltag."//]]>"; // Wordpress change the CDATA end tag
	if ($WPwordTube->wordtube_options['xhtmlvalid']) $replace .= $WPwordTube->xmltag.'// -->'; 
	$replace .= $WPwordTube->xmltag.'</script>'."\n";
	$replace = str_replace('var so =', 'var so'.$ID.' =', $replace);
	$replace = str_replace('so.addVariable', 'so'.$ID.'.addVariable', $replace);
	$replace = str_replace('so.addParam', 'so'.$ID.'.addParam', $replace);
	
	return $replace;
}
/****************************************************************/
/* Get category image
/****************************************************************/
function SetWordTubeMedia ($file, $image, $play_width, $play_height, $ID, $extension, $playertype, $all_options='', $use_tb=false, $vid='', $source='wt') {

	// Init parameters
	if ($source == 'wt' && class_exists('wordTubeClass')) {

		global $WPwordTube;
		$replace = get_ReturnMedia($ID, 1, $file, $image, $play_width, $play_height, true);

	} elseif ($source == 'pta') {

		if ($all_options == '') $all_options = get_pta_options_all(); 
		$callback = PTALBUM_URLPATH.'ptalbum-statistics.php';
		$player = PTALBUM_URLPATH.$playertype;

		$settings = '';
		$hs_width = $play_width+20;

	        $body = '<a href="http://www.macromedia.com/go/getflashplayer">Get the Flash Player</a> to see the wordTube Media Player.';
	
		// Prepare the script settings string
		if ($extension == "mp3" && $all_options['showeq']) {
				$settings .= "\n\t".'so'.$ID.'.addVariable("showeq", "true");';
				$play_height = 70; // fixed for equalizer
		}
		elseif ($extension == "mp3") $play_height = 20;
		
		$settings .= "\n\t".'so'.$ID.'.addVariable("autostart", "true");';
		if ($vid != '') $settings .= "\n\t".'so'.$ID.'.addVariable("id", "'.$vid.'");';
		if ($all_options['usewatermark']) $settings .= "\n\t".'so'.$ID.'.addVariable("logo", "'.$all_options['watermarkurl'].'");';
		if ($all_options['repeat']) $settings .= "\n\t".'so'.$ID.'.addVariable("repeat", "true");';
		if ($all_options['overstretch']) $settings .= "\n\t".'so'.$ID.'.addVariable("overstretch", "'.$all_options['overstretch'].'");';
		if ($all_options['showdigits']) $settings .= "\n\t".'so'.$ID.'.addVariable("showdigits", "true");';
		if ($all_options['showfsbutton']) $settings .= "\n\t".'so'.$ID.'.addVariable("showfsbutton", "true");';
		if ($all_options['statistic']) $settings .= "\n\t".'so'.$ID.'.addVariable("callback", "'.$callback.'");';
			
		$settings .= "\n\t".'so'.$ID.'.addVariable("backcolor", "0x'.$all_options['backcolor'].'");';
		$settings .= "\n\t".'so'.$ID.'.addVariable("frontcolor", "0x'.$all_options['frontcolor'].'");';
		$settings .= "\n\t".'so'.$ID.'.addVariable("lightcolor", "0x'.$all_options['lightcolor'].'");';
		$settings .= "\n\t".'so'.$ID.'.addVariable("volume", "'.$all_options['volume'].'");';
		$settings .= "\n\t".'so'.$ID.'.addVariable("bufferlength", "'.$all_options['bufferlength'].'");';

		// neeeded for IE problems
		$settings .= "\n\t".'so'.$ID.'.addVariable("width", "'.$play_width.'");';
		$settings .= "\n\t".'so'.$ID.'.addVariable("height", "'.$play_height.'");';

		if ($wordtube_options['showfsbutton']) {
			$settings .= "\n\t".'so'.$ID.'.addParam("allowfullscreen", "true");';
		} else {
			// transparent didn't work with fullscreen mode
			$settings .= "\n\t".'so'.$ID.'.addVariable("showfsbutton", "false");';
			$settings .= "\n\t".'so'.$ID.'.addParam("wmode", "transparent");';
		}

		// Starts build the final string wrapped in <script>
	    	$replace = "\n\t".'<script type="text/javascript">';
		if ($all_options['xhtmlvalid']) $replace .= "\n\t".'<!--';
		if ($all_options['xhtmlvalid']) $replace .= "\n\t".'//<![CDATA[';
		$replace .= "\n\t".'var so'.$ID.' = new SWFObject("'.$player.'", "1", "'.$play_width.'", "'.$play_height.'", "7", "#FFFFFF");';
		$replace .= "\n\t".'so'.$ID.'.addVariable("file", "'.$file.'");';
	
		$replace .= $settings;
		if ($use_tb) $replace .= "\n\t".'so'.$ID.'.write("myBody'.$ID.'");';

		if ($all_options['xhtmlvalid']) $replace .= "\n\t".'//]]>'; // Wordpress change the CDATA end tag
		if ($all_options['xhtmlvalid']) $replace .= "\n\t".'// -->';
		$replace .= "\n\t".'</script>'."\n";
	}

	return $replace;

}

?>