<?php
/*
Plugin Name: Post Thumb widgets
Plugin URI: http://www.alakhnor.com/post-thumb
Description: Adds sidebar widgets to display post-thumb revisited features
Version: 1.0
Author: Alakhnor
Author URI: http://www.alakhnor.com/post-thumb
*/

/**********************************************************************************
/* recent
**********************************************************************************/
function pt_widget_recent_entries($args) {
// return;
	if ( $output = wp_cache_get('pt_widget_recent_entries', 'widget') )
		return print($output);

	ob_start();
	extract($args);
	$options = get_option('pt_widget_recent_entries');
	$arg = GetWidgetArg($options);
	$title = empty($options['title']) ? __('Recent Posts') : $options['title'];
	if ( !$limit = (int) $options['limit'] )
		$limit = 10;
	else if ( $limit < 1 )
		$limit = 1;
	else if ( $limit > 15 )
		$limit = 15;

	$r = new WP_Query("showposts=$limit&what_to_show=posts&nopaging=0&post_status=publish");
	if ($r->have_posts()) :

		echo $before_widget;
			echo $before_title . $title . $after_title;
			echo '<ul>';
			while ($r->have_posts()) : $r->the_post();
				echo '<li>'.get_thumb('subfolder=recent'.$arg).'</li>';
			endwhile;
			echo '</ul>';
		echo $after_widget;

	endif;
	wp_cache_add('pt_widget_recent_entries', ob_get_flush(), 'widget');
}

function pt_flush_widget_recent_entries() {
	wp_cache_delete('pt_widget_recent_entries', 'widget');
}

// add_action('save_post', 'pt_flush_widget_recent_entries');
// add_action('deleted_post', 'pt_flush_widget_recent_entries');
// add_action('switch_theme', 'pt_flush_widget_recent_entries');

function pt_widget_recent_entries_control() {

	get_recent_control('pt-recent-entries', 'pt_widget_recent_entries');

}
/**********************************************************************************
/* random
**********************************************************************************/
function pt_widget_random_entries($args) {
	extract($args);
	$options = get_option('pt_widget_random_entries');
	$arg = GetWidgetArg($options);
	$title = empty($options['title']) ? __('Random Posts') : $options['title'];
	if ( !$limit = (int) $options['limit'] )
		$limit = 10;
	else if ( $limit < 1 )
		$limit = 1;
	else if ( $limit > 15 )
		$limit = 15;

	echo $before_widget;
		echo $before_title . $title . $after_title;
		echo '<ul>';
//		the_random_thumb('limit='.$limit.'&subfolder=random'.$arg,'li');
		echo '</ul>';
	echo $after_widget;
	return;
}
function pt_widget_random_entries_control() {
	get_recent_control('pt-random-entries', 'pt_widget_random_entries');
}


function pt_widgets_init() {

	$dims450 = array( 'height' => 450, 'width' => 300 );

	$widget_ops = array('classname' => 'widget_recent_entries', 'description' => __( "Thumbnails of your most recent posts") );
	wp_register_sidebar_widget('pt-recent-posts', __('PT Recent Posts'), 'pt_widget_recent_entries', $widget_ops);
	wp_register_widget_control('pt-recent-posts', __('PT Recent Posts'), 'pt_widget_recent_entries_control', $dims450);
	$widget_ops = array('classname' => 'widget_random_entries', 'description' => __( "Thumbnails of some randomly selected posts") );
	wp_register_sidebar_widget('pt-random-posts', __('PT Random Posts'), 'pt_widget_random_entries', $widget_ops);
	wp_register_widget_control('pt-random-posts', __('PT Random Posts'), 'pt_widget_random_entries_control', $dims450);

	if (function_exists('GetUserYoutubeVideo')) {
	       	wp_register_sidebar_widget ( 'pt-last-youtube', __('PT last Youtube'), 'pt_widget_last_youtube' );
		wp_register_widget_control ( 'pt-last-youtube', __('PT last Youtube'), 'pt_widget_last_youtube_control', $dims450);
	}
	
//	do_action('widgets_init');
}

add_action('init', 'pt_widgets_init');

/*********************************************************************************/
/* Get arg for recent widgets
/*********************************************************************************/
function GetWidgetArg($options) {

	$k 	= $options['keepratio'] ? '1' : '0';
	$w 	= $options['width'];
	$h 	= $options['height'];
	$lb 	= $options['LBeffect'] ? '1' : '0';
	$l 	= $options['limit'];
	$o 	= $options['offset'];
	$link 	= $options['link'];
	if ($link == '') $link='i';
	
	if ($options['showtitle'] =='') $st=''; else $st = '&showtitle='.$options['showtitle'];
	if ($options['thetitle'] != '') $tt = '&title='.$options['thetitle']; else $tt='';
	if ($options['category'] != '') $c = '&category='.$options['category']; else $c='';

	return '&width='.$w.'&height='.$h.'&keepratio='.$k.'&limit='.$l.'&LB_effect='.$lb.'&link='.$link.$c.$st.'&offset='.$o.$tt;

}
/*********************************************************************************/
/* Get recent posts widget control
/*********************************************************************************/
function get_recent_control($prefix, $option_name) {

	$options = $newoptions = get_option($option_name);
	if ( $_POST[$prefix.'-submit'] ) {
	
		$newoptions['width'] 	= strip_tags(stripslashes($_POST[$prefix.'-width']));
		$newoptions['height'] 	= strip_tags(stripslashes($_POST[$prefix.'-height']));
		$newoptions['keepratio']= isset($_POST[$prefix.'-keepratio']);
		$newoptions['limit']	= strip_tags(stripslashes($_POST[$prefix.'-limit']));
		$newoptions['offset'] 	= strip_tags(stripslashes($_POST[$prefix.'-offset']));
		$newoptions['category'] = strip_tags(stripslashes($_POST[$prefix.'-category']));
		$newoptions['link'] 	= strip_tags(stripslashes($_POST[$prefix.'-link']));
		$newoptions['showtitle']= strip_tags(stripslashes($_POST[$prefix.'-showtitle']));
		$newoptions['thetitle'] = strip_tags(stripslashes($_POST[$prefix.'-thetitle']));
		$newoptions['LBeffect'] = isset($_POST[$prefix.'-LBeffect']);
		$newoptions['title'] 	= strip_tags(stripslashes($_POST[$prefix.'-title']));
	}
	
	if ( $options != $newoptions ) {
	
		$options = $newoptions;
		update_option($option_name, $options);
	}

	if (wp_specialchars($options['width']=='')) $width = '80'; else $width = wp_specialchars($options['width']);
	if (wp_specialchars($options['height']=='')) $height = '60'; else $height = wp_specialchars($options['height']);
	$title = wp_specialchars($options['title']);
	$keepratio = $options['keepratio'] ? 'checked="checked"' : '';
	if (wp_specialchars($options['limit']=='')) $limit = '10'; else $limit = wp_specialchars($options['limit']);
	if (wp_specialchars($options['offset']=='')) $offset = '0'; else $offset = wp_specialchars($options['offset']);
	$category = wp_specialchars($options['category']);
	$showtitle = wp_specialchars($options['showtitle']);
	$thetitle = wp_specialchars($options['thetitle']);
	$media = $options['media'] ? 'checked="checked"' : '';
	$link = $options['link'];
	$LBeffect = $options['LBeffect'] ? 'checked="checked"' : '';

?>
	<p><label for="<?php echo $prefix; ?>-title"><?php _e('Title:'); ?> <input style="width: 240px;" id="<?php echo $prefix; ?>-title" name="<?php echo $prefix; ?>-title" type="text" value="<?php echo $title; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="<?php echo $prefix; ?>-keepratio"><?php _e('Keep ratio', 'post-thumb'); ?> <input class="checkbox" type="checkbox" <?php echo $keepratio; ?> id="<?php echo $prefix; ?>-keepratio" name="<?php echo $prefix; ?>-keepratio" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="<?php echo $prefix; ?>-width" style="text-align:right;"><?php _e('Width', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="<?php echo $prefix; ?>-width" name="<?php echo $prefix; ?>-width" value="<?php echo $width; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="<?php echo $prefix; ?>-height" style="text-align:right;"><?php _e('Height', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="<?php echo $prefix; ?>-height" name="<?php echo $prefix; ?>-height" value="<?php echo $height; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="<?php echo $prefix; ?>-limit" style="text-align:right;"><?php _e('Number of posts', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="<?php echo $prefix; ?>-limit" name="<?php echo $prefix; ?>-limit" value="<?php echo $limit; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="<?php echo $prefix; ?>-offset" style="text-align:right;"><?php _e('Offset of posts', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="<?php echo $prefix; ?>-offset" name="<?php echo $prefix; ?>-offset" value="<?php echo $offset; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="<?php echo $prefix; ?>-category" style="text-align:right;"><?php _e('Category filter', 'post-thumb'); ?> <input style="width: 40px;" type="text" value="<?php echo $category; ?>" id="<?php echo $prefix; ?>-category" name="<?php echo $prefix; ?>-category" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="<?php echo $prefix; ?>-showtitle" style="text-align:right;"><?php _e('Display mask', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="w<?php echo $prefix; ?>-showtitle" name="<?php echo $prefix; ?>-showtitle" value="<?php echo $showtitle; ?>" /></label></p>
	<p style="text-align:right;margin-right:20px;"><label for="<?php echo $prefix; ?>-link" style="text-align:right;"><?php _e('Link to', 'post-thumb'); ?>
		<select size="1" name="<?php echo $prefix; ?>-link" id="<?php echo $prefix; ?>-link">
			<option value="p" <?php if ($link == "p") echo 'selected="selected"'; ?>>Link to post</option>
			<option value="i" <?php if ($link == "i") echo 'selected="selected"'; ?>>Link to image</option>
			<option value="n" <?php if ($link == "n") echo 'selected="selected"'; ?>>No link</option>
			<option value="u" <?php if ($link == "u") echo 'selected="selected"'; ?>>Link to url</option>
		</select>
	</label>
	</p>
	<p style="text-align:right;margin-right:20px;"><label for="<?php echo $prefix; ?>-LBeffect"><?php _e('HS effect', 'post-thumb'); ?> <input class="checkbox" type="checkbox" <?php echo $LBeffect; ?> id="<?php echo $prefix; ?>-LBeffect" name="<?php echo $prefix; ?>-LBeffect" /></label></p>
	<input type="hidden" id="<?php echo $prefix; ?>-submit" name="<?php echo $prefix; ?>-submit" value="1" />
<?php

}
if (function_exists('GetUserYoutubeVideo')) {
	/*********************************************************************************/
	/* Get recent posts widget
	/*********************************************************************************/
	function pt_widget_last_youtube($args) {
	
		extract($args);
		$options = get_option('web_last_youtube');
		$author_id = trim($options['id']);
		$k 	= $options['keepratio'] ? '1' : '0';
		$w 	= $options['width'];
		$h 	= $options['height'];
		$title 	= empty($options['title']) ? __('Last youtube', 'post-thumb') : $options['title'];
		$XML = GetUserYoutubeVideo($author_id, 1);

		$id = $XML['id'];
		$ytitle = $XML['title'];
		$ythumb = $XML['thumbnail_url'];
		$arg = 'width='.$w.'&height='.$h.'&subfolder=last&keepratio=1&dirname=1';

		$t = new pt_thumbnail($ythumb, $arg);
		$thumb_url = $t->thumb_url;
		unset($t);

		?>
		<?php echo $before_widget; ?>
			<?php echo $before_title . $title . $after_title; ?>
			<ul>
				<li>
				<?php echo get_Youtube($id, $ytitle, $thumb_url);	?>
				</li>
			</ul>
		<?php echo $after_widget; ?>
	        <?php
	}
	/*********************************************************************************/
	/* Get recent posts widget control
	/*********************************************************************************/
	function pt_widget_last_youtube_control() {
	
		$options = $newoptions = get_option('web_last_youtube');
		if ( $_POST['web-last-youtube-submit'] ) {
		
			$newoptions['id'] 	= strip_tags(stripslashes($_POST['web-last-youtube-id']));
			$newoptions['title'] 	= strip_tags(stripslashes($_POST['web-last-youtube-title']));
			$newoptions['width'] 	= strip_tags(stripslashes($_POST['web-last-youtube-width']));
			$newoptions['height'] 	= strip_tags(stripslashes($_POST['web-last-youtube-height']));
		}
		if ( $options != $newoptions ) {
		
			$options = $newoptions;
			update_option('web_last_youtube', $options);
		}

		$title = wp_specialchars($options['title']);
		$id = wp_specialchars($options['id']);
		if (wp_specialchars($options['width']=='')) $width = '240'; else $width = wp_specialchars($options['width']);
		if (wp_specialchars($options['height']=='')) $height = '180'; else $height = wp_specialchars($options['height']);

	?>
		<p><label for="web-last-youtube-title"><?php _e('Title:'); ?> <input style="width: 240px;" id="web-last-youtube-title" name="web-last-youtube-title" type="text" value="<?php echo $title; ?>" /></label></p>
		<p style="text-align:right;margin-right:20px;"><label for="web-last-youtube-id" style="text-align:right;"><?php _e('User id', 'post-thumb'); ?> <input style="width: 250px;" type="text" id="web-last-youtube-id" name="web-last-youtube-id" value="<?php echo $id; ?>" /></label></p>
		<p style="text-align:right;margin-right:20px;"><label for="web-last-youtube-width" style="text-align:right;"><?php _e('Width', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="web-last-youtube-width" name="web-last-youtube-width" value="<?php echo $width; ?>" /></label></p>
		<p style="text-align:right;margin-right:20px;"><label for="web-last-youtube-height" style="text-align:right;"><?php _e('Height', 'post-thumb'); ?> <input style="width: 40px;" type="text" id="web-last-youtube-height" name="web-last-youtube-height" value="<?php echo $height; ?>" /></label></p>
		<input type="hidden" id="web-last-youtube-submit" name="web-last-youtube-submit" value="1" />
	<?php

	}
}
?>