<?php
/*
Plugin Name: Post Thumb Plugins
Plugin URI: http://www.alakhnor.com/post-thumb
Description: 	Plugin collection for Post-Thumb. Each plugin is separated with # lines.
		You can delete any plugin to save resources.
Version: 1.0
Author:  Alakhnor
Author URI: http://www.alakhnor.com/post-thumb

	Copyright (c) 2008 Alakhnor (http://www.alakhnor.com/post-thumb) for Post Thumb Revisited
	Post Thumb Revisited is released under the GNU General Public License (GPL)
	http://www.gnu.org/licenses/gpl.txt

	This is a WordPress 2 plugin (http://wordpress.org).
        Highslide JS is licensed under a Creative Commons Attribution-NonCommercial 2.5 License: http://creativecommons.org/licenses/by-nc/2.5/
        
List of plugins:
        
	Recent posts
	Excerpt
	RSS functions
	Youtube functions
	Scratch image
	Recent images
	        
*/

/*########################################################################
	Recent posts
	
########################################################################*/
/***********************************************************************************/
/* Echoes random posts
/***********************************************************************************/
function the_random_thumb($arg='', $litag='li', $earg='', $gibbs='d-m-y') {
	echo get_random_thumb($arg, $litag, $earg, $gibbs);
}
/***********************************************************************************/
/* Returns random posts
/***********************************************************************************/
function get_random_thumb($arg='', $litag='li', $earg='', $gibbs='d-m-y') {
	$new_args = pt_parse_arg($arg);
	if ($arg=='') $arg="orderby=rand()"; else $arg.= "&orderby=rand()";
	if (!isset($new_args['LIMIT'])) $arg.= "&limit=1";
	return get_recent_thumbs($arg, $litag, $earg, $gibbs);
}
/***********************************************************************************/
/* Echoes recent posts
/***********************************************************************************/
function the_recent_thumbs($arg='', $litag='li', $earg='', $gibbs='d-m-y') {
	echo get_recent_thumbs($arg, $litag, $earg, $gibbs);
}
/***********************************************************************************/
/* Returns recent posts
/***********************************************************************************/
function get_recent_thumbs($arg='', $litag='li', $earg='', $gibbs='d-m-y') {
	global $post;

	// Retrieves specific parameters
	$new_args = pt_parse_arg($arg);
	if (isset($new_args['OBJECT'])) $object = ($new_args['OBJECT']==1); else $object = false;
	if (isset($new_args['MEDIA'])) $media = $new_args['MEDIA']; else $media = 'all';
	if (isset($new_args['LIMIT'])) { $limit = $new_args['LIMIT']; settype($limit,"integer"); } else $limit = 8;
	if (isset($new_args['OFFSET'])) { $offset = $new_args['OFFSET']; settype($offset,"integer"); } else $offset = 0;
	if (isset($new_args['CATEGORY'])) { $cat_ID = $new_args['CATEGORY'];$catid = explode(',', $cat_ID);$cat_arg = '&cat='.$cat_ID;	} else {$cat_arg = '';$cat_ID='';$catid=array();}
	if (isset($new_args['SHOWMASK'])) $showmask = strtoupper($new_args['SHOWMASK']); else $showmask = 'I'; 
	if (isset($new_args['ORDER'])) $order = '&order='.strtoupper($new_args['ORDER']); else $order = ''; 
	if (isset($new_args['ORDERBY'])) $orderby = '&orderby='.strtolower($new_args['ORDERBY']); else $orderby = ''; 

	if ($media == '1') 
		$meta_key = '&meta_key=pt_metakey_med';
	elseif ($media == '2') 
		$meta_key = '&meta_key=pt_metakey_ytb';
	elseif ($media == '3') 
		$meta_key = '&meta_key=pt_metakey_';
	elseif ($media == '0') 
		$meta_key = '&meta_key=pt_metakey_img';
	else
		$meta_key = '';
	$content = '';
	if ($litag == '') $litag = 'span';

	// Create a query object to retrieve posts
	$r = pt_get_posts('showposts='.$limit.'&post_type=post&post_status=publish&offset='.$offset.$cat_arg.$meta_key.$orderby);
	foreach ($r as $post) :			
		setup_postdata($post);
		$mask = $showmask;
		while ($mask != '') :
			switch (substr($mask, 0, 1)) :
				case 'I' :
					$content .= '<'.$litag.' class="ptimg">'.get_thumb($arg).'</'.$litag.'>';
					break;
				case 'T' :
					if (get_the_title()) $t = get_the_title(); else $t = the_ID(); 
					$content .= '<'.$litag.' class="pttitle">'.'<a href="'.get_permalink().'">'.$t.'</a></'.$litag.'>';
					break;
				case 'A' :
					$content .= '<'.$litag.' class="ptauthor">'.get_the_author().'</'.$litag.'>';
					break;
				case 'E' :
					$content .= '<'.$litag.' class="ptexc">'.get_pt_excerpt($earg).'</'.$litag.'>';
					break;
				case 'C' :
					$content .= '<'.$litag.' class="ptcon">'.get_the_content().'</'.$litag.'>';
					break;
				case 'D' :
					$content .= '<'.$litag.' class="ptdate">'.get_the_time($gibbs).'</'.$litag.'>';
					break;
			endswitch;
			$mask = substr($mask, 1);
		endwhile;

	endforeach;
	
	unset ($r);

	if ($object) return $post_obj;

	return $content;
}
/***********************************************************************************/
/* get_posts hack
/***********************************************************************************/
function pt_get_posts($args) {
	global $wpdb;

	$defaults = array(
		'showposts' => 5, 'offset' => 0,
		'cat' => '', 'orderby' => 'post_date',
		'order' => 'DESC', 'include' => '',
		'exclude' => '', 'meta_key' => '',
		'meta_value' =>'', 'post_type' => 'post',
		'post_status' => 'publish', 'post_parent' => 0
	);

	$r = wp_parse_args( $args, $defaults );
	extract( $r, EXTR_SKIP );

	$showposts = (int) $showposts;
	$ecat = explode(',', $cat);
	$ducky = (int) $ecat[0];
	if ($ducky < 0) $exclcat = 'NOT '; else $exclcat = '';
	
	$cat = implode(',',$ecat);
	$offset = (int) $offset;
	$post_parent = (int) $post_parent;

	$inclusions = '';
	if ( !empty($include) ) {
		$offset = 0;    //ignore offset, category, exclude, meta_key, and meta_value, post_parent if using include
		$cat = 0;
		$exclude = '';
		$meta_key = '';
		$meta_value = '';
		$post_parent = 0;
		$incposts = preg_split('/[\s,]+/',$include);
		$showposts = count($incposts);  // only the number of posts included
		if ( count($incposts) ) {
			foreach ( $incposts as $incpost ) {
				if (empty($inclusions))
					$inclusions = ' AND ( ID = ' . intval($incpost) . ' ';
				else
					$inclusions .= ' OR ID = ' . intval($incpost) . ' ';
			}
		}
	}
	if (!empty($inclusions))
		$inclusions .= ')';

	$exclusions = '';
	if ( !empty($exclude) ) {
		$exposts = preg_split('/[\s,]+/',$exclude);
		if ( count($exposts) ) {
			foreach ( $exposts as $expost ) {
				if (empty($exclusions))
					$exclusions = ' AND ( ID <> ' . intval($expost) . ' ';
				else
					$exclusions .= ' AND ID <> ' . intval($expost) . ' ';
			}
		}
	}
	if (!empty($exclusions))
		$exclusions .= ')';

	$query  = "SELECT DISTINCT * FROM $wpdb->posts ";
	$query .= empty( $cat ) ? '' : ", $wpdb->term_relationships, $wpdb->term_taxonomy  ";
	$query .= empty( $meta_key ) ? '' : ", $wpdb->postmeta ";
	$query .= " WHERE 1=1 ";
	$query .= empty( $post_type ) ? '' : "AND post_type = '$post_type' ";
	$query .= empty( $post_status ) ? '' : "AND post_status = '$post_status' ";
	$query .= "$exclusions $inclusions " ;
	$query .= empty( $cat ) ? '' : "AND ($wpdb->posts.ID = $wpdb->term_relationships.object_id AND $wpdb->term_relationships.term_taxonomy_id = $wpdb->term_taxonomy.term_taxonomy_id AND $wpdb->term_taxonomy.term_id ".$exclcat."IN (" . $cat. ") AND $wpdb->term_taxonomy.taxonomy = 'category') ";
	$query .= empty( $post_parent ) ? '' : "AND $wpdb->posts.post_parent = '$post_parent' ";
	$query .= !empty( $meta_key ) && !empty($meta_value)  ? " AND ($wpdb->posts.ID = $wpdb->postmeta.post_id AND $wpdb->postmeta.meta_key = '$meta_key' AND $wpdb->postmeta.meta_value = '$meta_value' )" : '';
	$query .= !empty( $meta_key ) && empty($meta_value)  ? " AND ($wpdb->posts.ID = $wpdb->postmeta.post_id AND $wpdb->postmeta.meta_key LIKE '$meta_key%' )" : '';
	$query .= " GROUP BY $wpdb->posts.ID ORDER BY " . $orderby . ' ' . $order;

	if ( 0 < $showposts )
		$query .= " LIMIT " . $offset . ',' . $showposts;

	$posts = $wpdb->get_results($query);

	update_post_caches($posts);

	return $posts;
}

/*########################################################################
	Excerpt
	
########################################################################*/
/****************************************************************/
/*
/****************************************************************/
function get_pt_excerpt($arg='') {
	global $id, $post;

	$new_args = pt_parse_arg($arg);
	
	// Retrieves specific parameters
	if (isset($new_args['MORETEXT'])) $more_text = $new_args['MORETEXT']; else $more_text = "...";
	$link = isset($new_args['LINK']);
	if (isset($new_args['MORETAG'])) $more_tag = $new_args['MORETAG']; else $more_tag = "span";

	// if there's a password, return there.
	if (!empty($post->post_password)) {

		if ($_COOKIE['wp-postpass_'.COOKIEHASH] != $post->post_password) { // and it doesn't match cookie
			// if this runs in a feed
			if(is_feed())
				$output = __('There is no excerpt because this is a protected post.');
			else
				$output = get_the_password_form();
		}
		return $output;
	}


	// Create more link or more text
	if ($link) {
		if ($more_tag == '')
			$more_link = '';
		else
			$more_link = '<' . $more_tag . ' class="more-link">';
		$more_link .= '<a href="'.get_permalink().'" title="Permanent Link to '.get_the_title().'">' . $more_text . '</a>';
                if ($more_tag != '') $more_link .= '</' . $more_tag . '>' . "\n";
	} else
		$more_link = $more_text;

	return get_pt_excerpt_sub('', $more_link, $arg);
}
/****************************************************************/
/*
/****************************************************************/
function get_pt_excerpt_sub($text='', $morelink='...', $arg='') {
	global $post;

	$new_args = pt_parse_arg($arg);

	// Retrieves specific parameters
	$excerpt_length = 0;
	$excerpt_words = 0;
	if (isset($new_args['WORDS'])) $excerpt_words = $new_args['WORDS']; 
	elseif (isset($new_args['LENGTH'])) $excerpt_length = $new_args['LENGTH']; 
	else $excerpt_words = 55;
	if (isset($new_args['NOMORE'])) $no_more = ($new_args['NOMORE']==1); else $no_more = false;
	if (isset($new_args['SHOWDOTS'])) $showdots = '...'; else $showdots = '';
	if (isset($new_args['NOSEMIO'])) $no_semiologic = ($new_args['NOSEMIO']==1); else $no_semiologic = false;

	// First cleaning
	if ( '' == $text ) {
		$text = get_the_content('');
	};

	// Slice up to more tag if needed
	if (!$no_more && strpos($text, '<!--more-->')) {
		$temp = explode('<!--more-->', $text, 2);
		$text = $temp[0];
		unset($temp);
		$hasmore = true;
	} else 
		$hasmore = false;

	$text = pt_clean_text($text, $no_semiologic);
	$text = str_replace(']]>', ']]&gt;', $text);
	$text = strip_tags($text);

	$ellipsis = false;

	// Excerpt based on number of words
	if ($excerpt_words > 0) {

		$words = explode(' ', $text, $excerpt_words + 1);
		if (count($words) > $excerpt_words) {
			array_pop($words);
			if ($showdots != '') array_push($words, $showdots);
			$output = implode(' ', $words);
			$output .= $morelink;
		} else {
			$output = $text;
			$ellipsis = true;
			if ($hasmore) $output .= $morelink; 
		}

	// Excerpt based on number of characters
	} elseif ($excerpt_length > 0) {
		
		if (utf8_strlen($text)+3 > $excerpt_length) {
			$output = utf8_substr($text,0,$excerpt_length-3).$showdots.$morelink;
		} else {
			$output = $text;
			$ellipsis = true;
			if ($hasmore) $output .= $morelink; 
		}

	} else {
		$output = $text;
		$ellipsis = true;
		if ($hasmore) $output .= $morelink; 
	}

	return $output;
}
/*######################################################################
	RSS functions
	Use WP rss feed library
######################################################################*/

/****************************************************************/
/* Includes RSS functions
/****************************************************************/
// For function fetch_rss
if(file_exists(ABSPATH . WPINC . '/rss.php')) {
	@require_once (ABSPATH . WPINC . '/rss.php');
	// It's Wordpress 1.5.2 or 2.x. since it has been loaded successfully
} elseif (file_exists(ABSPATH . WPINC . '/rss-functions.php')) {
	@require_once (ABSPATH . WPINC . '/rss-functions.php');
	// In Wordpress 2.1, a new file name is being used
} else {
	die (__('Error in file: ' . __FILE__ . ' on line: ' . __LINE__ . '.<br />The Wordpress file "rss-functions.php" or "rss.php" could not be included.'));
}
/*******************************************************************
	ptRSS class
	(alpha version)
	 
	Builds a rss feed and return result
	Constructor:
		farg: feed arguments
			MASK: order of elements to display
			COUNT: number of item to display
		earg: excerpt arguments
		arg: thumbnail arguments
		
	ProcessFeed:	returns feed to display
	ProcessItem:	format item for display
	ProcessElement:	returns each element to insert in display mask
	GetThumbRSS: 	returns thumbnail
	GetExcerptRSS: 	return excerpt
	
	Usage:
		$rss = new ptRSS();
		echo $rss->ProcessFeed();
	
*******************************************************************/
class ptRSS {
	var $rss;
	var $feedStr = '';
	
	var $mask = 'TIE';
	var $count =5;
	
	/*********************************************************************/
	/* Constructor
	/*********************************************************************/
	function ptRSS ($farg='mask=TIE&count=5', $earg='', $arg='') {
	
		// Retrieves parameters
		$new_args = pt_parse_arg($farg);unset($farg);
		if (isset($new_args['MASK'])) $this->mask = strtoupper($new_args['MASK']);
		if (isset($new_args['COUNT'])) $this->count = (int) $new_args['COUNT'];
		$this->earg 	= $earg;	unset($earg);
		$thiq->arg 	= $arg;		unset($arg);

		if ($this->earg=='') $this->earg = 'words=40&moretag=1&moretext=[Read More]&link=1';
		if ($this->arg=='') $this->arg = 'rounded=0&subfolder=feeds&keepratio=0&width=100&height=70&append=0&&altappend=thumbrss_';
		
	}
	/*********************************************************************/
	/* Formats feed
	/*********************************************************************/
	function ProcessFeed ($feedurl) {

		if ($feedurl == '') return '';
		$this->feedurl 	= $feedurl;	unset($feedurl);
		// fetches feed
		$this->rss = fetch_rss($this->feedurl);

		// Process feed
		foreach ($this->rss->items as $item) :
			if ($this->count == 0) break;
			$this->altcounter = $display%2;
			$this->ProcessItem($item);
			$this->count--;
      		endforeach;
      		
      		return $this->feedStr;
	}
	/*********************************************************************/
	/* Formats item
	/*********************************************************************/
	function ProcessItem ($item) {

		$class = ($this->altcounter == 0) ? ' alter' : '';

              	// Do you have problems with special characters, then comment the follow four lines
		$item = encode_html($item);

		// Processes all elements of the mask
		$this->feedStr .= '<div class="feedrss'.$class.'">';
		$li = strlen($this->mask);
		for ($i=0;$i<$li;$i++) :
			$this->ProcessElement($item, substr($this->mask, $i, 1));
		endfor;
		$this->feedStr .= '</div>';
		
	}
	/*********************************************************************/
	/* Formats item element
	/*********************************************************************/
	function ProcessElement ($item, $element) {
		
		switch ($element) :
			case 'T' :
				$this->feedStr .= '<a href="'.$item['link'].'" title="'.$item['title'].'">'.$item['title'].'</a>';
				break;
			case 'I' :
				$this->feedStr .= $this->GetThumbRSS($item);
				break;
			case 'D' :
				$this->feedStr .= trim($item['description']);
				break;
			case 'E' :
				$this->feedStr .= $this->GetExcerptRSS($item);
				break;
		endswitch;
	
	}
	/*********************************************************************/
	/* 
	/*********************************************************************/
	function GetThumbRSS($item){

		$pattern = '@src=[\'"]http([^[:space:]\'">]*)\.(jpg|jpeg|gif|png)[\'"]@i';
		if (preg_match($pattern, $item['description'], $match)) {
			$rssimg = 'http'.$match[1].'.'.$match[2];
			if (remote_file_exists($rssimg)) {
				$p = new pt_thumbnail($rssimg, $this->arg);
				$rssthumb = $p->thumb_url;
				unset ($p);
				$thumbhtml = '<a href="'.$item['link'].'" title="'.$item['title'].'"><img src="'.$rssthumb.'" alt="'.$title.'" /></a>';
			}
 		}
		return $thumbhtml;
	}
	/*********************************************************************/
	/* 
	/*********************************************************************/
	function GetExcerptRSS($item){
	
		$new_args = pt_parse_arg($this->earg);
		
		// Retrieves specific parameters
		if (isset($new_args['MORETEXT'])) $more_text = $new_args['MORETEXT']; else $more_text = "...";
		$link = isset($new_args['LINK']);
		if (isset($new_args['MORETAG'])) $more_tag = $new_args['MORETAG']; else $more_tag = "span";
		if (isset($new_args['SHOWDOTS'])) $showdots = '...'; else $showdots = '';

		// Create more link or more text
		if ($link) {
			if ($more_tag == '')
				$more_link = '';
			else
				$more_link = '<' . $more_tag . ' class="more-link">';
			$more_link .= '<a href="'.$item['link'].'" title="Permanent Link to '.$item['title'].'">' . $more_text . '</a>';
	                if ($more_tag != '') $more_link .= '</' . $more_tag . '>' . "\n";
		} else
			$more_link = $more_text;

		$more_link = $showdots.$more_link;

		return get_pt_excerpt_sub($item['description'], $more_link, $this->earg);
	}
}
/****************************************************************/
/* Redefines previous_post_link
/****************************************************************/
function pt_previous_post_link($format='&laquo; %link', $link='%title', $in_same_cat = false, $excluded_categories = '') {

	if (is_attachment())
		$post = & get_post($GLOBALS['post']->post_parent);
	else
		$post = get_previous_post($in_same_cat, $excluded_categories);

	if (!$post) return;

        $hs_url = get_permalink($post->ID);
        $url_inframe = pt_return_get($hs_url);
	$title = apply_filters('the_title', $post->post_title, $post);
	$string = '<a href="'.$url_inframe.'">';
	$link = str_replace('%title', $title, $link);
	$link = $pre . $string . $link . '</a>';

	$format = str_replace('%link', $link, $format);

	echo $format;
}
/****************************************************************/
/* Redefines next_post_link
/****************************************************************/
function pt_next_post_link($format='%link &raquo;', $link='%title', $in_same_cat = false, $excluded_categories = '') {

	$post = get_next_post($in_same_cat, $excluded_categories);

	if (!$post) return;

        $hs_url = get_permalink($post->ID);
        $url_inframe = pt_return_get($hs_url);
	$title = apply_filters('the_title', $post->post_title, $post);
	$string = '<a href="'.$url_inframe.'">';
	$link = str_replace('%title', $title, $link);
	$link = $string . $link . '</a>';
	$format = str_replace('%link', $link, $format);

	echo $format;
}

/*########################################################################
	Youtube functions
	
	- get_last_youtube		Return author videos or with single id
		limit	: number of video to return if author is used
		author	: author name to fetch video from
		video	: single video id to retrieve
		echo	: display or return an array with videos
		before	: string to use before each video
		after	: string to use after each video
	
########################################################################*/

/****************************************************************/
/* Return Youtube User video
/****************************************************************/
function GetUserYoutubeVideo($youtube_user, $num=5) {
	if ($youtube_user=='') return;
	$url = 'http://gdata.youtube.com/feeds/api/users/'.$youtube_user.'/uploads?orderby=updated&start-index=1&max-results='.$num;
	$ytb = ParseYoutubeDetails(GetYoutubePage($url), false);
	if ($num == 1) return $ytb[0];
	return $ytb;
}
/****************************************************************/
/* Return Youtube single video
/****************************************************************/
function GetSingleYoutubeVideo($youtube_media) {
	if ($youtube_media=='') return;
	$url = 'http://gdata.youtube.com/feeds/api/videos/'.$youtube_media;
	$ytb = ParseYoutubeDetails(GetYoutubePage($url));
	return $ytb[0];
}
/****************************************************************/
/* Parse xml from Youtube
/****************************************************************/
function ParseYoutubeDetails($ytVideoXML, $show=false) {

	// Create parser, fill it with xml then delete it
	$yt_xml_parser = xml_parser_create();
	xml_parse_into_struct($yt_xml_parser, $ytVideoXML, $yt_vals);
	xml_parser_free($yt_xml_parser);
	
	// Init individual entry array and list array
	$yt_video = array();
	$yt_vidlist = array();

	// is_entry tests if an entry is processing
	$is_entry = true;
	// is_author tests if an author tag is processing
	$is_author = false;
	foreach ($yt_vals as $yt_elem) :

		// If no entry is being processed and tag is not start of entry, skip tag
		if (!$is_entry && $yt_elem['tag'] != 'ENTRY') continue;

		// Processed tag
		switch ($yt_elem['tag']) :
			case 'ENTRY' :
				if ($yt_elem['type'] == 'open') {
					$is_entry = true;
                                        $yt_video = array();
				} else {
					$yt_vidlist[] = $yt_video;
					$is_entry = false;
				}
			break;
			case 'ID' :
				$yt_video['id'] = substr($yt_elem['value'],-11);
				$yt_video['link'] = $yt_elem['value'];
			break;
			case 'PUBLISHED' :
				$yt_video['published'] = substr($yt_elem['value'],0,10).' '.substr($yt_elem['value'],11,8);
			break;
			case 'UPDATED' :
				$yt_video['updated'] = substr($yt_elem['value'],0,10).' '.substr($yt_elem['value'],11,8);
			break;
			case 'MEDIA:TITLE' :
				$yt_video['title'] = $yt_elem['value'];
			break;
			case 'MEDIA:KEYWORDS' :
				$yt_video['tags'] = $yt_elem['value'];
			break;
			case 'MEDIA:DESCRIPTION' :
				$yt_video['description'] = $yt_elem['value'];
			break;
			case 'MEDIA:CATEGORY' :
				$yt_video['category'] = $yt_elem['value'];
			break;
			case 'YT:DURATION' :
				$yt_video['duration'] = $yt_elem['attributes'];
			break;
			case 'MEDIA:THUMBNAIL' :
				if ($yt_elem['attributes']['HEIGHT'] == 240) {
					$yt_video['thumbnail'] = $yt_elem['attributes'];
					$yt_video['thumbnail_url'] = $yt_elem['attributes']['URL'];
				}
			break;
			case 'YT:STATISTICS' :
				$yt_video['viewed'] = $yt_elem['attributes']['VIEWCOUNT'];
			break;
			case 'GD:RATING' :
				$yt_video['rating'] = $yt_elem['attributes'];
			break;
			case 'AUTHOR' :
				$is_author = ($yt_elem['type'] == 'open');
			break;
			case 'NAME' :
				if ($is_author) $yt_video['author_name'] = $yt_elem['value'];
			break;
			case 'URI' :
				if ($is_author) $yt_video['author_uri'] = $yt_elem['value'];
			break;
			default :
		endswitch;
  	endforeach;
  	unset($yt_vals);
  
	return $yt_vidlist;
}
/****************************************************************/
/* Returns content of a remote page
/* Still need to do it without curl
/****************************************************************/
function GetYoutubePage($url) {

	// Try to use curl first
	if (function_exists('curl_init')) {
	
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
		$xml = curl_exec ($ch);
		curl_close ($ch);
	}
	// If not found, try to use file_get_contents (requires php > 4.3.0 and allow_url_fopen)
	else {
		$xml = file_get_contents($url);
	}
	
	return $xml;
}
/*********************************************************************************/
/* Get last youtube from a Youtube user or a single id
/*********************************************************************************/
function get_last_youtube($user_args='', $thumb_args='') {
	
	$defaults = array(
		'limit' => 1,
		'author' => '',
		'video' => '',
		'echo' => 1,
		'before' => '<li>',
		'after' => '</li>'
		);

	$args = wp_parse_args( $user_args, $defaults );
	extract($args);

	// Add dirname=1 to thumb name to include video id (otherwise will always be 0)
	if ($thumb_args != '') $thumb_args .= '&dirname=1';
	else $thumb_args = 'dirname=1';
	
	if ($author != '')
		$XML = GetUserYoutubeVideo($author, $limit);
	elseif ($video != '') 
		$XML = GetSingleYoutubeVideo($video);
	else return '';
	
	if (is_array($XML[0])) {
	
		if ($echo == 0) $ret = array();
		foreach ($XML as $ytb):

			$id = $ytb['id'];
			$ytitle = $ytb['title'];
			$ythumb = $ytb['thumbnail_url'];

			$t = new pt_thumbnail($ythumb, $thumb_args);
			$thumb_url = $t->thumb_url;
			unset($t);

			if ($echo == 1)
				echo $before.get_Youtube($id, $ytitle, $thumb_url).$after;
			else
				$ret[] = $before.get_Youtube($id, $ytitle, $thumb_url).$after;

		endforeach;
		if ($echo == 1) return $ret;
		
	} elseif (is_array($XML)) {

		$id = $XML['id'];
		$ytitle = $XML['title'];
		$ythumb = $XML['thumbnail_url'];

		$t = new pt_thumbnail($ythumb, $thumb_args);
		$thumb_url = $t->thumb_url;
		unset($t);

		if ($echo == 1)
			echo get_Youtube($id, $ytitle, $thumb_url);
		else
			return get_Youtube($id, $ytitle, $thumb_url);
	}
	
	return '';

}
/****************************************************************/
/* Get formatted youtube video
/****************************************************************/
function get_Youtube ($id, $title, $thumb) {
	return SetYoutubeVideo ($id, $title, $thumb, get_pt_options_all());
}

/*########################################################################
	Scratch image
	
	This function retrieves the first image from a post and deletes it from
	the post content. It may be used to squeeze the single post presentation.
########################################################################*/
function pt_ScratchImage($arg='', $hs=false, $caption=true, $addText='') {
	global $post;
	
	$image = array();
	$image['img'] = '';
	$image['alt'] = '';
	$image['imgsrc'] = '';
	$image['href'] = '';
	$image['thumb'] = '';	
	$pos_match = false;
	$do_replace = false;

       	// finds an image from the post content
	if (preg_match('@<img([^>]*)\/>@si', $post->post_content, $matches)) {

		// Save position for future use
		$pos_match = stripos($post->post_content, $matches[0]);
		$do_replace = true;

		// put matches into recognizable vars
		$la = pt_parseAtributes($matches[0], array('src', 'alt'));
		$image['img'] = $la['src'];
		$image['alt'] = $la['alt'];

		// Prepare for RegEx
		$img_src = str_replace(array("%", "|", "@", ")", "(", "'"), array("\%", "\|", "\@", "\)", "\(", "\'"), $image['img']);

		// detects if the image is already linked to a thumbnail
		$pattern = '%<a([^>]*).(jpg|jpeg|png|gif)([^>]*)\>([^>]*)'.$img_src.'([^\<]*)\<\/a>%si';
		if (preg_match($pattern,$post->post_content,$lighter)) {
			$pos_current = stripos($post->post_content, $lighter[0]);
			if ($pos_current < $pos_match) {
				$la = pt_parseAtributes($lighter[0], array('href'));
				$image['imgsrc'] = $la['href'];
			}
		}

		// detects if the image is linked to an url
		$pattern = '%<a([^>]*)>([^>]*)'.$img_src.'([^<]*)\<\/a>%i';
		if (preg_match($pattern,$post->post_content,$lighter)) {
			$pos_current = stripos($post->post_content, $lighter[0]);
			if ($pos_current < $pos_match) {
				$la = pt_parseAtributes($lighter[0], array('href'));
				$image['href'] = $la['href'];
			}
		}
		
		if ($image['href'] == '' && $image['imgsrc'] == '') {
			$do_replace_str = $matches[0];
		} else {
			$do_replace_str = $lighter[0];
		}
	}
	
       	// finds a wordtube media from the post content
	if (stripos($post->post_content, '[MEDIA=') !== false) {
		if (preg_match('@(?:<p>)*\s*\[MEDIA=([0-9]+%?)\]\s*(?:</p>)*@i', $post->post_content, $matches)) {

			$pos_current = stripos($post->post_content, $matches[0]);
			if ($pos_match === false || $pos_current < $pos_match) {

				$do_replace = false;
				global $WPwordTube;
				$dbresult = $WPwordTube->GetVidByID($matches[1]);
				if ($dbresult) {
					$image['imgsrc'] = '';
					$image['img'] = $dbresult->image;
				}
			}
		}
	}

	if (stripos($post->post_content, 'http://www.youtube.com/v/') !== false) {
		$pattern = '@(?:<p>)*\s*\<object([^>]*)>([^>]*)\<param([^>]*)value=[\'|"]http:\/\/www.youtube.com\/v\/(.*?)[\'|"]\>\<\/param>([^>]*)\<param(.*?)\<\/object>\s*(?:</p>)*@is';
		if (preg_match($pattern, $post->post_content, $matches)) {

			$pos_current = stripos($post->post_content, $matches[0]);
			if ($pos_match === false || $pos_current < $pos_match) {

				$do_replace = false;
				$ytbID = explode('&', $matches[4]);
				$image['imgsrc'] = '';
				$image['img'] = 'http://img.youtube.com/vi/'.$ytbID[0].'/0.jpg';
			}
		}
	}

	if ($do_replace) {
		$post->post_content = str_replace($do_replace_str, '', $post->post_content);
		setup_postdata($post);
	}

	if ($image['imgsrc'] != '') {
		$t = new pt_thumbnail($image['imgsrc'], $arg, false);
		$image['thumb'] = $t->thumb_url;
	} elseif ($image['img'] != '') {
		$t = new pt_thumbnail($image['img'], $arg, false);
		$image['thumb'] = $t->thumb_url;
	}

	if ($image['thumb'] != '') {
		if ($hs) {
			if ($image['href'] != '') {
			} elseif ($image['imgsrc'] != '') {
				$h = new pt_highslide($image['imgsrc'], $image['thumb'], $image['alt']);
				$h->set_borders(get_pt_options('ovframe'));
				$h->set_href_text('');
				$h->href_text .= $addText;
				if ($caption) $h->set_caption(htmlspecialchars(str_replace("'", "\'", $image['alt']), ENT_QUOTES));
				$image['html'] = '<div>'.$h->highslide_link('overlay').'<div style="clear: both"></div></div>';
				unset($h);
			} else {
				$h = new pt_highslide($image['img'], $image['thumb'], $image['alt']);
				$h->set_borders(get_pt_options('ovframe'));
				$h->set_href_text('');
				$h->href_text .= $addText;
				if ($caption) $h->set_caption(htmlspecialchars(str_replace("'", "\'", $image['alt']), ENT_QUOTES));
				$image['html'] = '<div>'.$h->highslide_link('overlay').'<div style="clear: both"></div></div>';
				unset($h);
			}
		} else {
			if ($image['imgsrc'] != '') {
				$image['html'] = '<a href="'.$image['imgsrc'].'"><img src="'.$image['thumb'].'" alt="'.$image['alt'].'" /></a>';
			} elseif ($image['href'] != '') {
				$image['html'] = '<a href="'.$image['href'].'"><img src="'.$image['thumb'].'" alt="'.$image['alt'].'" /></a>';
			} else {
				$image['html'] = '<a href="'.$image['img'].'"><img src="'.$image['thumb'].'" alt="'.$image['alt'].'" /></a>';
			}
		}
	}

        return $image;
}

/*########################################################################
	Recent images
	
	This function parse last post contents for image and thumbnailed them.
	It caches the result.
########################################################################*/
/***********************************************************************************/
/* List all recent images.
/* 	$arg: 		post-thumb parameters
/*	$slice:		number of posts to load for each loop of parsing
/*	$timeout:	cache delay in minutes
/***********************************************************************************/
function RecentImages ($arg='', $slice=5, $timeout=0) {
	global $PTRevisited, $wpdb;

	// check cache
	if ($timeout > 0) {
		$filename = 'recentimages'.md5($arg);
		$dirname = get_pt_options('base_path').'/'.get_pt_options('folder_name').'/_cache/';
		$ret_str = pt_load_cache($filename, $dirname, $timeout);
		if ($ret_str !== false) return $ret_str;
	}
	
	if (function_exists('ngg_addjs')) {
		include_once (NGGALLERY_ABSPATH."nggfunctions.php");
	}

	$ListImages = array();
	$ListImages['pic'] = array();
	$ListImages['endDB'] = false;

	// Retrieves specific parameters
	$new_args = pt_parse_arg($arg);
	if (isset($new_args['LIMIT'])) { 
		$limit = (int) $new_args['LIMIT']; 
	} else 
		$limit = 10;

	$offset = 0;
	$i = 0;
	while ($i < $limit):
        	$ListImages = RecentImages_sub ($ListImages, $slice, $offset, $i, $limit);
        	$offset = $offset+$slice;
        	$i = count($ListImages['pic']);
        	if ($ListImages['endDB']) break;
        endwhile;

	// Delete image in excess
	while (count($ListImages['pic']) > $limit) :
		array_pop($ListImages['pic']);
	endwhile;
	
	$ret_str = '';
	foreach ($ListImages['pic'] as $image):

		$t = new pt_thumbnail ($image[0], $arg);

		// Add thumbnail & highslide expand to image
		if (POSTTHUMB_USE_HS) {
			$h = new pt_highslide ($image[0], $t->thumb_url, $image[1]);
			$h->set_borders (get_pt_options('ovframe'));
			$h->set_title ($image[1]);
			if (get_pt_options('caption') == 'true')
				$h->set_caption (addslashes($image[1]));
			$h->set_html_size();
			$h->set_href_text('', $add_tag);
			$ret_str .= $h->highslide_link ();
			unset ($h);
		}
		// Simple replacement by thumbnail linked to image
		else $ret_str .= '<a href="'.$image[0].'" title="'.$image[1].'" ><img src="'.$t->thumb_url.'" alt="'.$image[1].'" /></a>';

		unset ($t);

	endforeach;
	
	unset($ListImages);
	
	if ($timeout > 0) pt_save_cache($filename, $dirname, $ret_str);
	return $ret_str;	
}
/***********************************************************************************/
/* List all recent images.
/*	$ListImages:	input and output parameter. Contain the list of images
/*	$offset:	post to skip to start new loop
/*	$i:		current counter
/*	$limit:		number of images to return
/***********************************************************************************/
function RecentImages_sub ($ListImages, $slice, $offset, $i, $limit) {
	global $PTRevisited, $PTRLibrary, $post;
	$attrList = array ("src");

	// Create a query object to retrieve posts
	$my_query = new WP_Query();
	$posts = $my_query->query('showposts='.$limit.'&offset='.$offset);
//	$posts = get_posts('numberposts='.$slice.'&offset='.$offset);
	if (count($posts) < $slice) $ListImages['endDB'] = true;

	foreach ($posts as $post) :

		if ($i>$limit) break;

		setup_postdata($post);		
		$content = get_the_content();
//		$content = apply_filters('the_content', $content);
//		$content = str_replace(']]>', ']]&gt;', $content);
//		$content = get_the_content();

		// Parse images
		$pattern = '/<img([^>]*)\/>/si';
		if (preg_match_all($pattern, $content, $matches, PREG_SET_ORDER)) {
			
			foreach ($matches as $match) :

				// Skip wp smileys
				if (stripos($match[0], 'smiley')) continue;
				if (stripos($match[0], 'sficon')) continue;
				if (stripos($match[0], 'jlanguage')) continue;
				if (stripos($match[0], 'icons')) continue;
				if (stripos($match[0], 'sfavatar')) continue;

				if ($i>$limit) break;
				if (!$PTRLibrary->p_rel) {
					if (stripos($match[0], 'rel="thumb"') === false && stripos($match[0], "rel='thumb'") === false)
						continue;
				} else {
					if (stripos($match[0], 'rel="nothumb"') !== false || stripos($match[0], "rel='nothumb'") !== false)
						continue;
				}

				$m = str_replace(array("%", "|", "@", ")", "("), array("\%", "\|", "\@", "\)", "\("), $match[0]);
				
				$pat = '%<a([^>]*)\>([^>]*)'.$m.'([^>]*)\<\/a>%si';
				if (preg_match($pat,$content,$macgee)) {
					if (stripos($match[0], 'sficon')) continue;
				}

				$pat = '%<a([^>]*).(jpg|jpeg|png|gif)([^>]*)\>([^>]*)'.$m.'([^>]*)\<\/a>%si';
				if (preg_match($pat,$content,$macgee)) {

					$ListAttr = pt_parseAtributes($macgee[0], array('href', 'title'));
					$ListImages['pic'][] =  array($ListAttr['href'], $ListAttr['title']);
					$i++;
					unset($macgee);

				} else {

					$ListAttr = pt_parseAtributes($match[1], array('src', 'alt'));
					$ListImages['pic'][] =  array($ListAttr['src'], $ListAttr['alt']);
					$i++;
				}

			endforeach;
		}
		
	endforeach;

	unset ($my_query);
	unset ($posts);
	
	return $ListImages;
	

}

?>